<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: 2.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: 2.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>import React, { Component } from "react";
import ResourceFilter from "./ResourceFilter";
import Button from "react-bootstrap/Button";
import OntologiesTable from "./OntologiesTable";
import { Form } from "react-bootstrap";
import Modal from "react-bootstrap/Modal";

/**
 * Ontology Search Based on Lexical Tokens page
 *
 * @component
 */
class _2 extends Component {
  /** @constructor */
  constructor(props) {
    super(props);
    this.state = {
      resourceFilter: "all",
      word: "",
      matcher: "exact",
      entities: ["classes"],
      scope: ["localName"],
      data: [],
      showPopup: false,
      popupMessage: "",
      popupTitle: "",
    };

    this.tableRef = React.createRef();
  }

  /**
   * Sets the browser tab name
   *
   * @method
   */
  componentDidMount() {
    document.title = "OOSP - Lexical Tokens";
  }

  /**
   * Scrolls to the table with ontology results
   *
   * @method
   */
  scrollToTable = () =>
    this.tableRef.current.scrollIntoView({ behavior: "smooth" });

  /**
   * Hides popups
   *
   * @method
   */
  hidePopup = () => {
    this.setState({ showPopup: false });
  };

  /**
   * Saves the state of a selected resource when the resource is changed
   *
   * @method
   * @param {String} resource - Selected resource
   */
  selectionChanged = (resource) => {
    this.setState({ resourceFilter: resource });
  };

  /**
   * Saves the state of a word to look for when input value changes
   *
   * @method
   * @param {Object} evt - onChange event of input field
   */
  wordChanged = (evt) => {
    const word = evt.target.value;
    this.setState({ word: word });
  };

  /**
   * Saves the selected matcher based on which radio button is pressed
   *
   * @param {Object} evt - onChange event of radio button
   * @method
   */
  matcherChanged = (evt) => {
    const matcher = evt.target.value;
    this.setState({ matcher: matcher });
  };

  /**
   * Saves the state of a check box from entities or scopes when it is checked/unchecked
   *
   * @param {Object} evt - onChange event of checkbox
   * @method
   */
  checkboxChanged = (evt) => {
    const name = evt.target.name;
    const value = evt.target.value;
    const checked = evt.target.checked;
    if (checked) {
      this.setState({ [name]: [...this.state[name], value] });
    } else {
      let state = { ...this.state };
      const index = state[name].findIndex((item) => item === value);
      if (index > -1) {
        state[name].splice(index, 1);
        this.setState(state);
      }
    }
  };

  /**
   * Fetches ontologies based on selected filters
   *
   * @method
   * @async
   */
  getData = async () => {
    const { resourceFilter, word, matcher, entities, scope } = {
      ...this.state,
    };

    if (!word) {
      this.setState({
        showPopup: true,
        popupTitle: "Error",
        popupMessage: "Word can not be empty",
      });
      return;
    }

    if (!entities.length) {
      this.setState({
        showPopup: true,
        popupTitle: "Error",
        popupMessage: "At least one entity needs to be selected",
      });
      return;
    }

    if (!scope.length) {
      this.setState({
        showPopup: true,
        popupTitle: "Error",
        popupMessage: "At least one scope needs to be selected",
      });
      return;
    }

    try {
      const res = await fetch(`/lexicalTokens`, {
        method: "POST",
        headers: {
          "Content-Type": "application/json",
          Accept: "application/zip",
        },
        body: JSON.stringify({
          resource: resourceFilter,
          word: word,
          matcher: matcher,
          entities: entities,
          scope: scope,
        }),
      });
      const data = await res.json();
      this.setState({ data: data }, () => {
        if (data.length) this.scrollToTable();
      });
    } catch (e) {
      console.error(e);
    }
  };

  /**
   * Renders Ontology Search Based on Lexical Tokens component
   *
   * @method
   */
  render() {
    const {
      data,
      word,
      matcher,
      entities,
      scope,
      resourceFilter,
      showPopup,
      popupTitle,
      popupMessage,
    } = this.state;

    return (
      &lt;>
        &lt;Modal show={showPopup} onHide={this.hidePopup}>
          &lt;Modal.Header closeButton>
            &lt;Modal.Title>{popupTitle}&lt;/Modal.Title>
          &lt;/Modal.Header>
          &lt;Modal.Body>{popupMessage}&lt;/Modal.Body>
        &lt;/Modal>
        &lt;h3>Ontology Search Based on Lexical Tokens&lt;/h3>
        &lt;ResourceFilter selectionChanged={this.selectionChanged} />
        &lt;div className="fulltext-search-controls">
          &lt;hr />
          &lt;b>Word:&lt;/b>
          &lt;Form.Control
            as="input"
            className="word-input"
            name="word"
            onChange={this.wordChanged}
          />
          &lt;hr />
          &lt;b>Matcher:&lt;/b>
          &lt;Form.Check
            inline
            type="radio"
            name="matcher"
            label="Exact match"
            value="exact"
            defaultChecked={true}
            onChange={this.matcherChanged}
          />
          {/* &lt;label htmlFor="exact">&lt;/label> */}
          &lt;Form.Check
            inline
            type="radio"
            name="matcher"
            label="Word match (fulltext)"
            value="fulltext"
            onChange={this.matcherChanged}
          />
          {/* &lt;label htmlFor="fulltetx">&lt;/label> */}
          &lt;hr />
          &lt;b>Entities:&lt;/b>
          &lt;Form.Check
            inline
            type="checkbox"
            name="entities"
            label="Classes"
            value="classes"
            defaultChecked={true}
            onChange={this.checkboxChanged}
          />
          {/* &lt;label htmlFor="classes">Classes&lt;/label> */}
          &lt;Form.Check
            inline
            type="checkbox"
            name="entities"
            label="Properties"
            value="properties"
            onChange={this.checkboxChanged}
          />
          {/* &lt;label htmlFor="properties">Properties&lt;/label> */}
          &lt;Form.Check
            inline
            type="checkbox"
            name="entities"
            label="Individuals"
            value="individuals"
            onChange={this.checkboxChanged}
          />
          {/* &lt;label htmlFor="individuals">Individuals&lt;/label> */}
          &lt;hr />
          &lt;b>Scope:&lt;/b>
          &lt;Form.Check
            inline
            type="checkbox"
            name="scope"
            label="Local name"
            value="localName"
            defaultChecked={true}
            onChange={this.checkboxChanged}
          />
          {/* &lt;label htmlFor="localName">Local name&lt;/label> */}
          &lt;Form.Check
            inline
            type="checkbox"
            name="scope"
            label="Label"
            value="label"
            onChange={this.checkboxChanged}
          />
          {/* &lt;label htmlFor="label">Label&lt;/label> */}
          &lt;Form.Check
            inline
            type="checkbox"
            name="scope"
            label="Comment"
            value="comment"
            onChange={this.checkboxChanged}
          />
          {/* &lt;label htmlFor="comment">Comment&lt;/label> */}
          &lt;hr />
        &lt;/div>
        &lt;Button onClick={this.getData} className="get-data-btn">
          Get Ontology Set according to Full Text Search
        &lt;/Button>
        &lt;OntologiesTable
          data={data}
          page="2"
          word={word}
          matcher={matcher}
          entities={entities}
          scope={scope}
          resourceFilter={resourceFilter}
          tableRef={this.tableRef}
        />
      &lt;/>
    );
  }
}

export default _2;
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="-_1.html">_1</a></li><li><a href="-_2.html">_2</a></li><li><a href="AnnotationMetricsFilters.html">AnnotationMetricsFilters</a></li><li><a href="AnnotationsDistribution.html">AnnotationsDistribution</a></li><li><a href="AxiomFrequencyDistribution.html">AxiomFrequencyDistribution</a></li><li><a href="AxiomMetricsFilters.html">AxiomMetricsFilters</a></li><li><a href="AxiomTypesDistribution.html">AxiomTypesDistribution</a></li><li><a href="ChartPopup.html">ChartPopup</a></li><li><a href="ClassesFrequencyDistribution.html">ClassesFrequencyDistribution</a></li><li><a href="ClassExpressionTypeMetricsFilters.html">ClassExpressionTypeMetricsFilters</a></li><li><a href="DetailMetricsFilters.html">DetailMetricsFilters</a></li><li><a href="DLConstructsDistribution.html">DLConstructsDistribution</a></li><li><a href="DomainRangeDefinitionDistribution.html">DomainRangeDefinitionDistribution</a></li><li><a href="EntitiyMetricsFilters.html">EntitiyMetricsFilters</a></li><li><a href="Home.html">Home</a></li><li><a href="InstancesFrequencyDistribution.html">InstancesFrequencyDistribution</a></li><li><a href="Navigation.html">Navigation</a></li><li><a href="OntologiesTableClass.html">OntologiesTableClass</a></li><li><a href="OWL2ProfilesAndReasoning.html">OWL2ProfilesAndReasoning</a></li><li><a href="OWL2ProfilesDistribution.html">OWL2ProfilesDistribution</a></li><li><a href="ResourceFilter.html">ResourceFilter</a></li><li><a href="Tab.html">Tab</a></li><li><a href="Tabs.html">Tabs</a></li><li><a href="TaxonomyMetricsFilters.html">TaxonomyMetricsFilters</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.6</a> on Sun Apr 11 2021 17:29:26 GMT+0200 (stredoeurópsky letný čas)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
